﻿using System;
using System.Threading;

namespace NanoMvvm.Demo.Async.ViewModels
{
    public class MainViewModel : WorkspaceViewModel
    {
        private AsyncTaskViewModel operation;

        public MainViewModel()
        {
            Operation = new AsyncTaskViewModel(() => Thread.Sleep(8000));
            Operation.PeriodDuration = 1000;
            Operation.Started += (sender, args) => StartOperationCommand.Header = "Running";
            Operation.Completed += (sender, args) => StartOperationCommand.Header = "Finished";

            StartOperationCommand = new CommandViewModel(
                "Start", new DelegateCommand(() => Operation.Start(), () => !Operation.IsRunning && !Operation.IsFinished));
        }

        public AsyncTaskViewModel Operation
        {
            get
            {
                return operation;
            }

            set
            {
                SetProperty(ref operation, value, () => Operation);
            }
        }

        public CommandViewModel StartOperationCommand { get; set; }
    }
}