﻿using System;
using System.Windows.Input;

namespace NanoMvvm.Demo.Commands.Testing
{
    public class SimpleDelegateCommand : ICommand
    {
        private readonly Action executeHandler;
        private readonly Func<bool> canExecuteHandler;

        public SimpleDelegateCommand(Action execute, Func<bool> canExecute = null)
        {
            if (execute == null) throw new ArgumentNullException("execute");

            executeHandler = execute;
            canExecuteHandler = canExecute;
        }

        public void Execute(object parameter)
        {
            executeHandler();
        }

        public bool CanExecute(object parameter)
        {
            return canExecuteHandler == null || canExecuteHandler();
        }

        public event EventHandler CanExecuteChanged;

        public void RaiseCanExecuteChanged()
        {
            if(CanExecuteChanged != null)
            {
                CanExecuteChanged(this, EventArgs.Empty);
            }
        }
    }
}