﻿using System;
using System.Threading;
using System.Windows.Input;

namespace NanoMvvm.Demo.Commands.Testing
{
    public class StrongReferenceDelegateCommand : DelegateCommand
    {
        public StrongReferenceDelegateCommand(Action execute) : base(execute)
        {
        }

        public StrongReferenceDelegateCommand(Action execute, Func<bool> canExecute) : base(execute, canExecute)
        {
        }

        private event EventHandler StrongHandler;

        protected override void OnCanExecuteChangedAddEventHandler(EventHandler handler)
        {
            StrongHandler += handler;
        }

        protected override void OnCanExecuteChangedRemoveEventHandler(EventHandler handler)
        {
            StrongHandler -= handler;
        }

        protected override void OnCanExecuteChanged(ICommand sender)
        {
            if (SynchronizationContext != null)
            {
                SynchronizationContext.Send(state => OnCanExecuteChangedImpl(), null);
            }
            else
            {
                OnCanExecuteChangedImpl();
            }
        }

        private void OnCanExecuteChangedImpl()
        {
            if(StrongHandler != null)
            {
                StrongHandler(this, EventArgs.Empty);
            }
        }
    }
}