﻿using NanoMvvm.Demo.Commands.Testing;

namespace NanoMvvm.Demo.Commands.ViewModels
{
    public class MainWindowViewModel : WorkspaceViewModel
    {

        public MainWindowViewModel()
        {
            AutomaticDisableTargetCommand = new CommandViewModel<DelegateCommand>("Disable", new DelegateCommand(DisableCommand1));
            AutomaticTargetCommand = new CommandViewModel<DelegateCommand>("Do Stuff", new DelegateCommand(TargetMethod1, CanExecute1));

            DisableTargetCommand = new CommandViewModel<DelegateCommand>("Disable*", new DelegateCommand(DisableCommand2));
            TargetCommand = new CommandViewModel<DelegateCommand>("Do Stuff*", new DelegateCommand(TargetMethod2, CanExecute2));

            StrongDisableTargetCommand = new CommandViewModel<StrongReferenceDelegateCommand>("Disable**", new StrongReferenceDelegateCommand(DisableCommand3));
            StrongTargetCommand = new CommandViewModel<StrongReferenceDelegateCommand>("Do Stuff**", new StrongReferenceDelegateCommand(TargetMethod3, CanExecute3));

            SimpleDisableCommand = new SimpleDelegateCommand(DisableCommand4);
            SimpleTargetCommand = new SimpleDelegateCommand(TargetMethod4, CanExecute4);


            DisableTargetCommand.Command.IsAutomaticRequeryDisabled = true;
            TargetCommand.Command.IsAutomaticRequeryDisabled = true;

            StrongDisableTargetCommand.Command.IsAutomaticRequeryDisabled = true;
            StrongTargetCommand.Command.IsAutomaticRequeryDisabled = true;

            Condition1 = true;
            Condition2 = true;
            Condition3 = true;
            Condition4 = true;
        }

        public CommandViewModel<DelegateCommand> AutomaticDisableTargetCommand { get; set; }
        public CommandViewModel<DelegateCommand> AutomaticTargetCommand { get; set; }

        public CommandViewModel<DelegateCommand> DisableTargetCommand { get; set; }
        public CommandViewModel<DelegateCommand> TargetCommand { get; set; }

        public CommandViewModel<StrongReferenceDelegateCommand> StrongDisableTargetCommand { get; set; }
        public CommandViewModel<StrongReferenceDelegateCommand> StrongTargetCommand { get; set; }

        public SimpleDelegateCommand SimpleDisableCommand { get; set; }
        public SimpleDelegateCommand SimpleTargetCommand { get; set; }

        public bool Condition1 { get; set; }

        public bool Condition2 { get; set; }

        public bool Condition3 { get; set; }

        public bool Condition4 { get; set; }

        private void DisableCommand1()
        {
            AutomaticDisableTargetCommand.Header = Condition1 ? "Enable" : "Disable";

            Condition1 = !Condition1;
        }

        private void TargetMethod1()
        {

        }

        private bool CanExecute1()
        {
            return Condition1;
        }

        private void DisableCommand2()
        {
            DisableTargetCommand.Header = Condition2 ? "Enable*" : "Disable*";

            Condition2 = !Condition2;

            TargetCommand.Command.RaiseCanExecuteChanged();
        }

        private void TargetMethod2()
        {

        }

        private bool CanExecute2()
        {
            return Condition2;
        }

        private void DisableCommand3()
        {
            StrongDisableTargetCommand.Header = Condition3 ? "Enable**" : "Disable**";

            Condition3 = !Condition3;

            StrongTargetCommand.Command.RaiseCanExecuteChanged();
        }

        private void TargetMethod3()
        {

        }

        private bool CanExecute3()
        {
            return Condition3;
        }

        private void DisableCommand4()
        {
            Condition4 = !Condition4;

            SimpleTargetCommand.RaiseCanExecuteChanged();
        }

        private void TargetMethod4()
        {

        }

        private bool CanExecute4()
        {
            return Condition4;
        }
    }
}