﻿using System;
using System.Linq;

namespace NanoMvvm.Demo.Selection.ViewModels
{
    public class MainViewModel : WorkspaceViewModel
    {
        public MainViewModel()
        {
            const string One = "One";
            const string Two = "Two";
            const string Three = "Three";
            const string Four = "Four";

            FreeSelection = new SelectionViewModel<string>();
            FreeSelection.Add(One);
            FreeSelection.Add(Two);
            FreeSelection.Add(Three);
            FreeSelection.Add(Four);

            UpToOneSelection = new SelectionViewModel<string> { SelectionPolicy = SelectionPolicy.UpToOne };
            UpToOneSelection.Add(One);
            UpToOneSelection.Add(Two);
            UpToOneSelection.Add(Three);
            UpToOneSelection.Add(Four);

            ExactlyOneSelection = new SelectionViewModel<string> { SelectionPolicy = SelectionPolicy.ExactlyOne };
            ExactlyOneSelection.Add(One);
            ExactlyOneSelection.Add(Two);
            ExactlyOneSelection.Add(Three);
            ExactlyOneSelection.Add(Four);

            AtLeastOneSelection = new SelectionViewModel<string> { SelectionPolicy = SelectionPolicy.AtLeastOne };
            AtLeastOneSelection.Add(One);
            AtLeastOneSelection.Add(Two);
            AtLeastOneSelection.Add(Three);
            AtLeastOneSelection.Add(Four);

            AlternateDisabledSelection = new SelectionViewModel<string>();
            AlternateDisabledSelection.Add(One);
            AlternateDisabledSelection.Add(Two, false);
            AlternateDisabledSelection.Add(One);
            AlternateDisabledSelection.Add(Two, false);
            AlternateDisabledSelection.Add(One);
            AlternateDisabledSelection.Add(Two, false);
            AlternateDisabledSelection.Add(One);
            AlternateDisabledSelection.Add(Two, false);

            CurrentSelectionPolicy = new SelectionViewModel<object> { SelectionPolicy = SelectionPolicy.ExactlyOne };
            foreach (var item in Enum.GetValues(typeof(SelectionPolicy)).Cast<SelectionPolicy>())
            {
                CurrentSelectionPolicy.Add(item);
            }

            CurrentSelectionPolicy.ItemSelected +=
                (sender, args) => AlternateDisabledSelection.SelectionPolicy = (SelectionPolicy)args.Item;
        }

        public SelectionViewModel<string> FreeSelection { get; set; }

        public SelectionViewModel<string> UpToOneSelection { get; set; }

        public SelectionViewModel<string> ExactlyOneSelection { get; set; }

        public SelectionViewModel<string> AtLeastOneSelection { get; set; }

        public SelectionViewModel<string> AlternateDisabledSelection { get; set; }

        public SelectionViewModel<object> CurrentSelectionPolicy { get; set; }
    }
}