﻿using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using System.Windows;

namespace NanoMvvm.Demo.Simple
{
    public sealed class AppModel
    {
        private static SplashScreenViewModel ssvm;
        private static MainViewModel mvm;

        public static void Run()
        {
            NanoMvvmFramework.Initialize(Application.Current);

            NanoMvvmFramework.Instance.Application.ShutdownMode = ShutdownMode.OnExplicitShutdown;

            ssvm = new SplashScreenViewModel {IsActive = true};

            Task.Factory.StartNew<IEnumerable<Match>>(LoadData)
                .ContinueWith(t => OnDataLoadFinished(t.Result)
                              , TaskScheduler.FromCurrentSynchronizationContext());
        }

        private static IEnumerable<Match> LoadData()
        {
            return DataRepository.GetMatches();
        }

        private static void OnDataLoadFinished(IEnumerable<Match> data)
        {
            mvm = new MainViewModel();

            mvm.LoadMatches(data);

            ssvm.IsActive = false;

            mvm.IsActive = true;

            NanoMvvmFramework.Instance.Application.ShutdownMode = ShutdownMode.OnLastWindowClose;
        }
    }
}