﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using NanoMvvm.Demo.Simple.Utility;

namespace NanoMvvm.Demo.Simple
{
    public static class DataRepository
    {
        private static readonly IEnumerable<Match> matches; 
        private static readonly IDictionary<int, MatchResult> results;
 
        static DataRepository()
        {
            matches = new List<Match>
                          {
                              new Match
                                  {
                                      LeagueName = "First Fun National",
                                      MatchId = 100,
                                      Team1Name = "Fun Grapefruit Rovers",
                                      Team2Name = "Fun Taffy Bungers",
                                      PlayLocation = "The Super Bowl",
                                      PlayTime = DateTime.Now - TimeSpan.FromDays(10)
                                  },
                              new Match
                                  {
                                      LeagueName = "First Fun National",
                                      MatchId = 101,
                                      Team1Name = "Fun Grapefruit Rovers",
                                      Team2Name = "Fun Cucumber Roosters",
                                      PlayLocation = "The Super Bowl",
                                      PlayTime = DateTime.Now - TimeSpan.FromDays(9)
                                  },
                              new Match
                                  {
                                      LeagueName = "First Fun National",
                                      MatchId = 102,
                                      Team1Name = "Fun Cucumber Roosters",
                                      Team2Name = "Fun Choppy Ploppers",
                                      PlayLocation = "The Mega Dish",
                                      PlayTime = DateTime.Now - TimeSpan.FromDays(8)
                                  },
                              new Match
                                  {
                                      LeagueName = "First Fun National",
                                      MatchId = 103,
                                      Team1Name = "Fun Perky Bloomers",
                                      Team2Name = "Fun Choppy Ploppers",
                                      PlayLocation = "The Mega Dish",
                                      PlayTime = DateTime.Now - TimeSpan.FromDays(6)
                                  },
                              new Match
                                  {
                                      LeagueName = "First Fun National",
                                      MatchId = 104,
                                      Team1Name = "Fun Runny Footers",
                                      Team2Name = "Fun Shorty Campers",
                                      PlayLocation = "The Super Bowl",
                                      PlayTime = DateTime.Now - TimeSpan.FromDays(4)
                                  }
                          };

            results = new Dictionary<int, MatchResult>
                          {
                              {100, new MatchResult(0, 0)},
                              {101, new MatchResult(0, 1)},
                              {102, new MatchResult(1, 0)},
                              {103, null},
                              {104, new MatchResult(3, 0)}
                          };
        }

        public static IEnumerable<Match> GetMatches()
        {
            Debug.Assert(matches != null);

            TimeHelper.Delay(3000);
            return matches;
        }

        public static MatchResult GetMatchResult(int matchId)
        {
            TimeHelper.Delay(3000);

            //simulate an error
            if(matchId == 104) throw new DataException("Cannot find match data.");

            return results[matchId];
        }
    }
}