﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Linq.Expressions;

namespace NanoMvvm.UnitTests
{
    [TestClass]
    public class ExpressionResolverTests
    {
        public class TestObject
        {
            public int Value { get; set; }
        }

        public int MemberValue { get; set; }


        [TestMethod]
        public void GetParameterMemberNameTest()
        {
            Expression<Func<TestObject, int>> memberExpression = o => o.Value;

            const string expected = "Value";
            string actual = ExpressionResolver.GetMemberName<TestObject, int>(memberExpression);

            Assert.AreEqual(expected, actual);
        }

        [TestMethod]
        public void GetMemberNameTest()
        {
            Expression<Func<int>> memberExpression = () => MemberValue;

            const string expected = "MemberValue";
            string actual = ExpressionResolver.GetMemberName<int>(memberExpression);

            Assert.AreEqual(expected, actual);
        }

        [TestMethod]
        public void GetMemberNameFromNewTest()
        {
            Expression<Func<int>> memberExpression = () => new TestObject().Value;

            const string expected = "Value";
            string actual = ExpressionResolver.GetMemberName<int>(memberExpression);

            Assert.AreEqual(expected, actual);
        }
    }
}
